%{?mingw_package_header}

%global _basename libsndfile

Summary:	Library for reading and writing sound files
Name:		mingw-%{_basename}
Version:	1.0.25
Release:	4%{?dist}
License:	LGPLv2+ and GPLv2+ and BSD
Group:		System Environment/Libraries
URL:		http://www.mega-nerd.com/libsndfile/
Source0:	http://www.mega-nerd.com/libsndfile/files/%{_basename}-%{version}.tar.gz
Patch0:		libsndfile-1.0.25-system-gsm.patch
BuildRoot:	%(mktemp -ud %{_tmppath}/%{_basename}-%{version}-%{release}-XXXXXX)

#BuildRequires:	mingw32-alsa-lib
BuildRequires:	pkgconfig
BuildRequires:	libtool

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:	mingw32-flac
BuildRequires:	mingw32-libogg
BuildRequires:	mingw32-libvorbis
BuildRequires:	mingw32-sqlite
BuildRequires:	mingw32-gsm

BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:	mingw64-flac
BuildRequires:	mingw64-libogg
BuildRequires:	mingw64-libvorbis
BuildRequires:	mingw64-sqlite
BuildRequires:	mingw64-gsm


%description
libsndfile is a C library for reading and writing sound files such as
AIFF, AU, WAV, and others through one standard interface. It can
currently read/write 8, 16, 24 and 32-bit PCM files as well as 32 and
64-bit floating point WAV files and a number of compressed formats. It
compiles and runs on *nix, MacOS, and Win32.


%package -n mingw32-%{_basename}
Summary:	Library for reading and writing sound files
Group:		Development/Libraries


%description -n mingw32-%{_basename}
libsndfile is a C library for reading and writing sound files such as
AIFF, AU, WAV, and others through one standard interface.
This is the MinGW version, built for the win32 target.


%package -n mingw32-%{_basename}-utils
Summary:	Command Line Utilities for libsndfile
Group:		Applications/Multimedia
Requires:	mingw32-%{_basename} = %{version}-%{release}
Obsoletes:	mingw32-%{_basename} < 1.0.20-4


%description -n mingw32-%{_basename}-utils
libsndfile is a C library for reading and writing sound files such as
AIFF, AU, WAV, and others through one standard interface.
This package contains command line utilities for libsndfile.
This is the MinGW version, built for the win32 target.


%package -n mingw64-%{_basename}
Summary:	Library for reading and writing sound files
Group:		Development/Libraries


%description -n mingw64-%{_basename}
libsndfile is a C library for reading and writing sound files such as
AIFF, AU, WAV, and others through one standard interface.
This is the MinGW version, built for the win64 target.


%package -n mingw64-%{_basename}-utils
Summary:	Command Line Utilities for libsndfile
Group:		Applications/Multimedia
Requires:	mingw64-%{_basename} = %{version}-%{release}
Obsoletes:	mingw64-%{_basename} < 1.0.20-4


%description -n mingw64-%{_basename}-utils
libsndfile is a C library for reading and writing sound files such as
AIFF, AU, WAV, and others through one standard interface.
This package contains command line utilities for libsndfile.
This is the MinGW version, built for the win64 target.


%{?mingw_debug_package}


%prep
%setup -q -n %{_basename}-%{version}
%patch0 -p1
rm -r src/GSM610 ; autoreconf -I M4 # for system-gsm patch


%build
%mingw_configure \
	--disable-dependency-tracking \
	--enable-sqlite \
	--enable-alsa \
	--enable-largefile \
	--disable-static

# Get rid of rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' build_win32/libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' build_win32/libtool
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' build_win64/libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' build_win64/libtool

%mingw_make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT __docs
%mingw_make install DESTDIR=$RPM_BUILD_ROOT
cp -pR $RPM_BUILD_ROOT%{mingw32_docdir}/libsndfile1-dev/html __docs_32
rm -rf $RPM_BUILD_ROOT%{mingw32_docdir}/libsndfile1-dev
cp -pR $RPM_BUILD_ROOT%{mingw64_docdir}/libsndfile1-dev/html __docs_64
rm -rf $RPM_BUILD_ROOT%{mingw64_docdir}/libsndfile1-dev

# fix multilib issues
%ifarch x86_64 s390x ia64 ppc64 sparc64
%define wordsize 64
%else
%define wordsize 32
%endif

mv %{buildroot}%{mingw32_includedir}/sndfile.h \
   %{buildroot}%{mingw32_includedir}/sndfile-%{wordsize}.h
mv %{buildroot}%{mingw64_includedir}/sndfile.h \
   %{buildroot}%{mingw64_includedir}/sndfile-%{wordsize}.h

cat > %{buildroot}%{mingw32_includedir}/sndfile.h <<EOF
#ifdef __WIN32__
# include "sndfile-32.h"
#elif defined(__WIN64__)
# include "sndfile-64.h"
#else
# error "unexpected value for __WORDSIZE macro"
#endif
EOF
cp -p %{buildroot}%{mingw32_includedir}/sndfile.h \
	%{buildroot}%{mingw64_includedir}/sndfile.h

%if 0%{?rhel} != 0
rm -f %{buildroot}%{mingw32_bindir}/sndfile-jackplay
rm -f %{buildroot}%{mingw64_bindir}/sndfile-jackplay
%endif


%clean
rm -rf $RPM_BUILD_ROOT


%files -n mingw32-%{_basename}
%defattr(-,root,root,-)
%doc COPYING AUTHORS README NEWS
%{mingw32_bindir}/libsndfile-1.dll
%doc __docs_32/*
%doc ChangeLog
%exclude %{mingw32_libdir}/libsndfile.la
%{mingw32_includedir}/sndfile.h
%{mingw32_includedir}/sndfile.hh
%{mingw32_includedir}/sndfile-%{wordsize}.h
%{mingw32_libdir}/libsndfile.dll.a
%{mingw32_libdir}/pkgconfig/sndfile.pc

%files -n mingw32-%{_basename}-utils
%defattr(-,root,root,-)
%{mingw32_bindir}/%{mingw32_target}-sndfile-cmp.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-concat.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-convert.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-deinterleave.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-info.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-interleave.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-metadata-get.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-metadata-set.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-play.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-regtest.exe
%{mingw32_bindir}/%{mingw32_target}-sndfile-salvage.exe
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-cmp.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-concat.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-convert.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-deinterleave.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-info.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-interleave.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-metadata-get.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-metadata-set.1*
%{mingw32_mandir}/man1/%{mingw32_target}-sndfile-play.1*


%files -n mingw64-%{_basename}
%defattr(-,root,root,-)
%doc COPYING AUTHORS README NEWS
%{mingw64_bindir}/libsndfile-1.dll
%doc __docs_64/*
%doc ChangeLog
%exclude %{mingw64_libdir}/libsndfile.la
%{mingw64_includedir}/sndfile.h
%{mingw64_includedir}/sndfile.hh
%{mingw64_includedir}/sndfile-%{wordsize}.h
%{mingw64_libdir}/libsndfile.dll.a
%{mingw64_libdir}/pkgconfig/sndfile.pc

%files -n mingw64-%{_basename}-utils
%defattr(-,root,root,-)
%{mingw64_bindir}/%{mingw64_target}-sndfile-cmp.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-concat.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-convert.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-deinterleave.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-info.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-interleave.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-metadata-get.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-metadata-set.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-play.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-regtest.exe
%{mingw64_bindir}/%{mingw64_target}-sndfile-salvage.exe
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-cmp.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-concat.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-convert.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-deinterleave.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-info.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-interleave.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-metadata-get.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-metadata-set.1*
%{mingw64_mandir}/man1/%{mingw64_target}-sndfile-play.1*


%changelog
* Fri May 17 2013 Steven Boswell <ulatekh@yahoo.com> - 1.0.25-4
- Ported to MinGW

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.25-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.25-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sat Nov 12 2011 Ville Skyttä <ville.skytta@iki.fi> - 1.0.25-2
- Patch to use system libgsm instead of a bundled copy.
- Make main package dep in -devel ISA qualified.
- Drop -octave Provides (not actually built with octave > 3.0).
- Don't build throwaway static lib.
- Run test suite during build.

* Thu Jul 14 2011 Michal Hlavinka <mhlavink@redhat.com> - 1.0.25-1
- Update to 1.0.25
- fixes integer overflow by processing certain PAF audio files (#721240)

* Sun Mar 27 2011 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.24-1
- Update to 1.0.24

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Oct 16 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.23-1
- Update to 10.0.23

* Tue Oct 05 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.22-1
- Update to 10.0.22

* Tue May 11 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.21-1
- Update to 10.0.21
- Do not include the static library in the package (RHBZ#556074)
- Remove BR on jack since sndfile-jackplay is not provided anymore

* Mon Feb  1 2010 Stepan Kasal <skasal@redhat.com> - 1.0.20-5
- Do not build against Jack on RHEL
- Fix the Source0: URL
- Fix the licence tag

* Sat Nov 14 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.20-4
- Split utils into a subpackage

* Sat Nov 14 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 1.0.20-3
- Add FLAC/Ogg/Vorbis support (BR: libvorbis-devel)
- Make build verbose
- Remove rpath
- Fix ChangeLog encoding
- Move the big Changelog to the devel package

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.20-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat Jun 06 2009 Lennart Poettering <lpoetter@redhat.com> - 1.0.20-1
- Updated to 1.0.20

* Tue Mar 03 2009 Robert Scheck <robert@fedoraproject.org> - 1.0.17-8
- Rebuilt against libtool 2.2

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.17-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Oct 25 2008 Andreas Thienemann <andreas@bawue.net> - 1.0.17-6
- Removed spurious #endif in the libsndfile.h wrapper. Thx to Edward
  Sheldrake for finding it. Fixes #468508.
- Fix build for autoconf-2.63

* Thu Oct 23 2008 Andreas Thienemann <andreas@bawue.net> - 1.0.17-5
- Fixed multilib conflict. #342401
- Made flac support actually work correctly.

* Thu Aug  7 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.0.17-4
- fix license tag

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.0.17-3
- Autorebuild for GCC 4.3

* Thu Sep 20 2007 Andreas Thienemann <andreas@bawue.net> - 1.0.17-2
- Adding FLAC support to libsndfile courtesy of gentoo, #237575
- Fixing CVE-2007-4974. Thanks to the gentoo people for the patch, #296221

* Fri Sep 08 2006 Andreas Thienemann <andreas@bawue.net> - 1.0.17-1
- Updated to 1.0.17

* Sun Apr 30 2006 Andreas Thienemann <andreas@bawue.net> - 1.0.16-1
- Updated to 1.0.16

* Thu Mar 30 2006 Andreas Thienemann <andreas@bawue.net> - 1.0.15-1
- Updated to 1.0.15

* Thu Mar 16 2006 Dams <anvil[AT]livna.org> - 1.0.14-1.fc5
- Updated to 1.0.14
- Dropped patch0

* Thu May 12 2005 Michael Schwendt <mschwendt[AT]users.sf.net> - 1.0.11-3
- rebuilt

* Sat Mar  5 2005 Michael Schwendt <mschwendt[AT]users.sf.net> - 1.0.11-2
- Fix format string bug (#149863).
- Drop explicit Epoch 0.

* Sat Dec  4 2004 Ville Skyttä <ville.skytta@iki.fi> - 0:1.0.11-0.fdr.1
- Update to 1.0.11.

* Wed Oct 13 2004 Ville Skyttä <ville.skytta@iki.fi> - 0:1.0.10-0.fdr.1
- Update to 1.0.10, update URLs, include ALSA support.
- Disable dependency tracking to speed up the build.
- Add missing ldconfig invocations.
- Make -devel require pkgconfig.
- Include developer docs in -devel.
- Provide -octave in main package, own more related dirs.
- Bring specfile up to date with current spec templates.

* Sat Apr 12 2003 Dams <anvil[AT]livna.org>
- Initial build.
