#!/bin/bash

# First, download all the source packages.
pushd SRPMS
yumdownloader --source flac libid3tag libmad libsamplerate libsndfile \
	portaudio portmidi protobuf taglib

# Then install all the source packages.
# These were the current packages from Fedora Core 18 as of 18-May-2013;
# yours may vary.
rpm -i flac-1.2.1-10.fc18.src.rpm \
	libid3tag-0.15.1b-13.fc18.src.rpm \
	libmad-0.15.1b-15.fc18.src.rpm \
	libsamplerate-0.1.8-3.fc18.src.rpm \
	libsndfile-1.0.25-4.fc18.src.rpm \
	portaudio-19-16.fc18.src.rpm \
	portmidi-217-7.fc18.src.rpm \
	protobuf-2.4.1-12.fc18.src.rpm \
	taglib-1.8-3.20121215git.fc18.src.rpm
popd

# Then build all the MinGW packages!
rpmbuild -ba SPECS/mingw-flac.spec
rpmbuild -ba SPECS/mingw-libid3tag.spec
rpmbuild -ba SPECS/mingw-libmad.spec
rpmbuild -ba SPECS/mingw-libsamplerate.spec
rpmbuild -ba SPECS/mingw-libsndfile.spec
rpmbuild -ba SPECS/mingw-portaudio.spec
rpmbuild -ba SPECS/mingw-portmidi.spec
rpmbuild -ba SPECS/mingw-protobuf.spec
rpmbuild -ba SPECS/mingw-taglib.spec
